#ifndef __STDISO_H
#define __STDISO_H
//
//  (C) Copyright 1993-2008 by Autodesk, Inc.  All rights reserved.
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//

#include "AdAChar.h"

class STDIMP_DLLSHARE AcmStandardISO : public AcmStandard
{
public:
  ACRX_DECLARE_MEMBERS(AcmStandardISO);

  AcmStandardISO();
  virtual ~AcmStandardISO();
  
  virtual LPCTSTR originalName() const;             

  virtual Adesk::Boolean acmInit();             
  
  virtual void getTextHeightList(AcGeDoubleArray& txtArr) const;

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Adesk::Boolean setDimDefaults();

protected:
  virtual void initArrowServices();
  virtual Adesk::Boolean createDefaultStyle();
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmStandardISO);


class STDIMP_DLLSHARE AcmSurfTextStdISO : public AcmSurfTextStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmSurfTextStdISO);

  AcmSurfTextStdISO();
  virtual ~AcmSurfTextStdISO();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual void initToEditOriginal();
  virtual void initToEdit();
  virtual Adesk::Boolean setFactoryDefaults();

  virtual Adesk::Boolean getLaySymbolList(AcmCObjArray<AcmCSymbolDesc>& list,
                                          const AcmCSurfText* pSubSym =NULL) const;

  virtual Acm::ErrorStatus checkVisibility(AcmCSurfText* pData) const;
  virtual Acm::ErrorStatus initFields(AcmCSurfText* pData) const ;
  virtual Acm::ErrorStatus setSuggested(AcmCSurfText* pData) const;

  virtual Acad::ErrorStatus getVarFromDlgIndex(Adesk::UInt8 dlgIndex, Acm::Variable& var) const;
  virtual AcmSurfTextStd::ConfigListState checkConfigListState(Acm::Variable var, CVarDlgInfo& varDlgInfo) const;
  virtual void restoreAllSuggestedList();
  virtual void getDefaultLaySymbols(AcDbIntArray& symArray) const;
  virtual void getDefaultVarSuggestList(Acm::Variable var, CStringList& list) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmSurfTextStdISO);

class STDIMP_DLLSHARE AcmSurfTextStdISO2002 : public AcmSurfTextStdISO
{
public:
  ACRX_DECLARE_MEMBERS(AcmSurfTextStdISO2002);

  AcmSurfTextStdISO2002();
  virtual ~AcmSurfTextStdISO2002();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;

  virtual Acad::ErrorStatus getVarFromDlgIndex(Adesk::UInt8 dlgIndex, Acm::Variable& var) const;
  virtual AcmSurfTextStd::ConfigListState checkConfigListState(Acm::Variable var, CVarDlgInfo& varDlgInfo) const;
  virtual Acm::ErrorStatus checkVisibility(AcmCSurfText* pData) const;
  virtual Acm::ErrorStatus initFields(AcmCSurfText* pData) const ;
  virtual Acm::ErrorStatus setSuggested(AcmCSurfText* pData) const;
  virtual void restoreAllSuggestedList();
  virtual void getDefaultVarSuggestList(Acm::Variable var, CStringList& list) const;

protected:
  virtual void getHeights(const AcmCSurfText* pSymb,
                          double& H1,
                          double& H2) const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmSurfTextStdISO2002);

class STDIMP_DLLSHARE AcmFCFStdISO : public AcmFCFStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmFCFStdISO);

  AcmFCFStdISO();
  virtual ~AcmFCFStdISO();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual Adesk::Boolean setFactoryDefaults();
  virtual void initToEditOriginal();
  virtual void initToEdit();

  virtual Adesk::Boolean getArrowDesc(AcmCObjArray<AcmCArrowDesc>& list,Adesk::Boolean allSrv = Adesk::kTrue) const;

  virtual Adesk::Boolean getMat(AcmCObjArray<AcmCGDTSymbolDesc>& list) const;

  virtual Acm::ErrorStatus checkVisibility(AcmCFCF* pData) const;
  virtual void getSubEnts(const AcmCFCF* pSubSym,
                       AcmCAuxEntArray& subents, AcGePoint3d* pSecondLeaderPnt = NULL) const;
  virtual Acm::ArrowType defaultSecondaryArrowType() const;
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmFCFStdISO);


class STDIMP_DLLSHARE AcmWeldingStdISO : public AcmWeldingStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmWeldingStdISO);

  AcmWeldingStdISO();
  virtual ~AcmWeldingStdISO();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual Acm::ErrorStatus cInit();
  virtual void initToEditOriginal();
  virtual void initToEdit();

  virtual Adesk::Boolean setFactoryDefaults();
  virtual void setDefaultSubSymbol(AcmCSubWelding* pData) const;

  virtual Acm::ErrorStatus checkVisibility(AcmCSubWelding* pData) const;
  virtual Adesk::Boolean   initPost(AcmCWeld* pWeld) const;

  virtual void getSubEnts(const AcmCSubWelding* pSubSym,
                          AcmCAuxEntArray& subents,
                          AcGePoint3d& ptRefEnd) const;

  virtual void getWeldProcessPrefix(CString& bufStr) const;

protected:
  virtual Acm::ErrorStatus createDefaultLTypeIdentLine(const ACHAR* name);
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmWeldingStdISO);


class STDIMP_DLLSHARE AcmDatumStdISO : public AcmDatumStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmDatumStdISO);

  AcmDatumStdISO();
  virtual ~AcmDatumStdISO();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
  virtual Adesk::Boolean setFactoryDefaults();
  virtual Acm::ErrorStatus cInit();
};                      

MAKE_ACDBOPENOBJECT_FUNCTION(AcmDatumStdISO);


class STDIMP_DLLSHARE AcmIdStdISO : public AcmIdStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmIdStdISO);
  
  AcmIdStdISO();
  virtual ~AcmIdStdISO();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;

  virtual Adesk::Boolean getDatumArrowDesc(AcmCObjArray<AcmCArrowDesc>& list) const;
  virtual Acm::ArrowType defaultArrowType() const;
};

MAKE_ACDBOPENOBJECT_FUNCTION(AcmIdStdISO);

class STDIMP_DLLSHARE AcmCPartListStdISO : public AcmCPartListStd
{
public:
  AcmCPartListStdISO(AcmBOMStd *std);
  virtual ~AcmCPartListStdISO();

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;

};

class STDIMP_DLLSHARE AcmCBalloonStdISO : public AcmCBalloonStd
{
public:
  AcmCBalloonStdISO(AcmBOMStd *std);
  virtual ~AcmCBalloonStdISO();

  virtual Adesk::Boolean setFactoryDefaults();
  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;

};

class STDIMP_DLLSHARE AcmBOMStdISO : public AcmBOMStd
{
public:
  ACRX_DECLARE_MEMBERS(AcmBOMStdISO);

  AcmBOMStdISO();
  virtual ~AcmBOMStdISO();

  virtual Acm::ErrorStatus cInit();
  virtual Adesk::Boolean setFactoryDefaults();

  virtual Acm::ErrorStatus getRevision(CString& rev, Adesk::UInt16& year) const;
  virtual Adesk::Boolean   isCompatibleTo(const AcmStandard* pStd) const;
};

MAKE_ACDBOPENOBJECT_FUNCTION(AcmBOMStdISO);

#endif // STDISO
